unit u_Snoop;

interface

uses Messages, Windows;

const

  WM_MYTRAYMSG = WM_USER+$101;
  WM_MYEXITMSG = WM_USER+$102;
  WM_MYHOTKEYRESET = WM_USER+$103;

  MyClassName : PChar =
    'TPhantom';
  ConsoleWndClassName : PChar =
    'tty';
  ProgramInfo : PChar =
    ' by Dr. Golomin';
  sNoPluginFound : PChar =
    '   ""     plug-in'''#10#13+
    '       ';
  sProgramTerminating : PChar =
    ' "" ';
  sPluginRegisterhotKeyFailed : PChar =
    '     '#10#13+
    '-    .';
  sPleaseReleaseModifiers : PChar =
    '     '#10#13+
    ' ( 1.5 )  Ctrl, Alt, Shift  Win';
  sCopyTextTimeOutExpired : PChar =
    '  3       '#10#13+
    '    .  .'#10#13+
    '  ?';
  ProgrammerInfo : PChar =
    ':,PAF,SAZ,,'#10#13+
    ': http://www.ipom.ru/golomin';
  Info : PChar =
    'Qwerty<-> '#10#13+
    '1.  '#10#13+
    '2.   (ScrollLock)';
  Payment : PChar =
    '    " 2"  ?'#10#13+
    '     (.  Payment.txt)';
  FirstInfo : PChar =
    '   " 2"';
  Stat : String =
    ' :            '#10#13+
    ' :            '#0;
  LogFileName : PChar =
    'Snoop.log';
  msAboutProgram : PChar =
    ' ...';
  msStatistics : PChar =
    '...';
  msAboutPlugins : PChar =
    ' ';
  msMessages : PChar =
    ' ';
  msIgnoreLights : PChar =
    '  ';
  msReinstallHook : PChar =
    '...';
  msExit : PChar =
    '';
  sMAINICON : PChar =
    'MAINICON';
  sTRAYICON : PChar =
    'TRAYICON';
  sTrayHint : PChar =
    ' v 2.705';
  sPluginFileMask : PChar =
    '*.dll';
  sEnumSnoopServicesProcName : PChar =
    'EnumSnoopServices';
  sSoftwareSnoop : PChar =
    'Software\Snoop-Dogg Computing\Snoop2';
  sDiagsOn : PChar =
    'Diagnostic messages';
  sIgnoreLightsOn : PChar =
    'Ignore keyboard lights';

  idmAbout = 2;
  idmExit = 1;
  idmStatistics = 3;
  idmMessages = 4;
  idmIgnoreLights = 5;
  idmReinstallHook = 6;
  idmPluginBase = 10;

  idtCancelRecode = 1;
  idtRestoreClipboard = 2;

type
  TSnoopTranslate = function (lParam,HOut:Integer;Var HIn:Integer):Longint;StdCall;
  TEnumSnoopServices = function (Var Info:PChar;Var Proc:TSnoopTranslate;Var ScanCode:Integer;Var Modifiers:Integer;Var Copy:LongBool;Var Paste:LongBool;Var lParam:Longint;Var Reserved:Pointer):LongBool;stdcall;

  TPlugIn=Record
    Info:PChar;
    Module:Integer;
    ScanCode,Modifiers:Integer;
    Copy,Paste:LongBool;
    lParam:Longint;
    Reserved:Pointer;
    ProcAddress:TSnoopTranslate;
    Enabled:Boolean;
  end;

function StrLCopy(p1,p2:PChar;count:integer):integer;
function StrLen(p:PChar):integer;
function StrComp(p1,p2:PChar):Integer;
procedure IntToPChar(Int:DWORD;Buf:PChar);
function IsModifierPressed:Boolean;
procedure QuitForNoPlugins;
procedure EmulateCopy;
procedure EmulatePaste;

implementation

function StrLen(p:PChar):integer;
begin
  Result:=0;
  while p^<>#0 do
    begin
      inc(Result);
      inc(p);
    end;
end;

function StrLCopy(p1,p2:PChar;count:integer):integer;
begin
  Result:=StrLen(p2);
  if count<Result
    then
      Result:=Count;
  for Count:=1 to result do
    begin
      p1^:=p2^;
      inc(p2);
      inc(p1);
    end;
end;

function StrComp(p1,p2:PChar):Integer;
begin
  while (p1^<>#0) and (p2^<>#0) do
    begin
      Result:=ord(p1^)-ord(p2^);
      if Result<>0
        then
          exit;
      inc(p1);
      inc(p2);
    end;
  if (p1^<>#0)
    then
      Result:=1
    else
      if (p2^<>#0)
        then
          Result:=-1
        else
          Result:=0;
end;

procedure IntToPChar(Int:DWORD;Buf:PChar);
var
  IntLen:byte;
  Power:Comp;
begin
  if Int=0
    then
      begin
        Buf^:='0';
        exit;
      end;
  IntLen:=0;
  Power:=1;
  repeat
    if Int>=Power
      then
        inc(IntLen);
    Power:=Power*10;
  until Power>Int;
  inc(Buf,IntLen-1);
  repeat
    Buf^:=Chr(Int mod 10+Ord('0'));
    Int:=Int div 10;
    Dec(Buf);
  until Int=0;
end;

function IsModifierPressed:Boolean;
begin
  Result:=(GetKeyState(VK_MENU) and $F0000000<>0) or (GetKeyState(VK_SHIFT) and $F0000000<>0) or (GetKeyState(VK_CONTROL) and $F0000000<>0) or (GetKeyState(VK_RWIN) and $F0000000<>0) or (GetKeyState(VK_LWIN) and $F0000000<>0)
end;

procedure QuitForNoPlugins;
begin
  MessageBox(0,sNoPluginFound,sProgramTerminating,MB_OK);
  PostQuitMessage(0);
end;

procedure EmulateCopy;
begin
  keybd_event(VK_CONTROL,$1d,0,0);
  keybd_event(VK_INSERT,$52,KEYEVENTF_EXTENDEDKEY,0);
  keybd_event(VK_INSERT,$52,KEYEVENTF_KEYUP+KEYEVENTF_EXTENDEDKEY,0);
  keybd_event(VK_CONTROL,$1d,KEYEVENTF_KEYUP,0);
end;

procedure EmulatePaste;
begin
  keybd_event(VK_SHIFT,$2a,0,0);
  keybd_event(VK_INSERT,$52,KEYEVENTF_EXTENDEDKEY,0);
  keybd_event(VK_INSERT,$52,KEYEVENTF_KEYUP+KEYEVENTF_EXTENDEDKEY,0);
  keybd_event(VK_SHIFT,$2a,KEYEVENTF_KEYUP,0);
end;

end.
